function varargout = diffraction(varargin)
% DIFFRACTION M-file for diffraction.fig
%      DIFFRACTION, by itself, creates a new DIFFRACTION or raises the existing
%      singleton*.
%
%      H = DIFFRACTION returns the handle to a new DIFFRACTION or the handle to
%      the existing singleton*.
%
%      DIFFRACTION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DIFFRACTION.M with the given input arguments.
%
%      DIFFRACTION('Property','Value',...) creates a new DIFFRACTION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before diffraction_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to diffraction_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help diffraction

% Last Modified by GUIDE v2.5 28-Mar-2014 16:57:59

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @diffraction_OpeningFcn, ...
                   'gui_OutputFcn',  @diffraction_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before diffraction is made visible.
function diffraction_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to diffraction (see VARARGIN)

% Choose default command line output for diffraction
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes diffraction wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = diffraction_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    d= get(hObject,'value');%this is the slit width in micro meter.............. check this 
    set(handles.edit1,'String',d);
    d=d*1e-6;  
    lambda= get(handles.slider3,'value');% this is the wavelength of light in nano meter
    set(handles.edit3,'String',(lambda+400));
    lambda=(lambda+400)*1e-9;
    s= get(handles.slider2,'value');%this is the distance between screen and slit in meters
    set(handles.edit2,'String',s);
    
    thetamax=pi/10;
    theta=-thetamax:1e-6:thetamax;
    y=s*tan(theta);
    alpha=pi*d*sin(theta)/lambda;
    x=((sinc(alpha)).^2); %(sin(alpha)./alpha).^2; 
    plot(y,x);
    title('Single slit diffraction ');
    xlabel('Distance (m)');
    ylabel('Intensity');
% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 thetamax=pi/10;
    d= get(handles.slider1,'value');%this is the slit width in micro meter.............. check this 
    set(handles.edit1,'String',d);
    d=d*1e-6;  
    lambda= get(handles.slider3,'value');% this is the wavelength of light in nano meter
    set(handles.edit3,'String',(lambda+400));
    lambda=(lambda+400)*1e-9;
    s= get(hObject,'value');%this is the distance between screen and slit in meters
    set(handles.edit2,'String',s);
    theta=-thetamax:1e-6:thetamax;
    y=s*tan(theta);
    alpha=pi*d*sin(theta)/lambda;
    x=((sinc(alpha)).^2); %(sin(alpha)./alpha).^2; 
    plot(y,x);
    title('Single slit diffraction ');
    xlabel('Distance (m)');
    ylabel('Intensity');
% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider3_Callback(hObject, eventdata, handles)
% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
thetamax=pi/10;
    d= get(handles.slider1,'value');%this is the slit width in micro meter.............. check this 
    set(handles.edit1,'String',d);
    d=d*1e-6;  
    lambda= get(hObject,'value');% this is the wavelength of light in nano meter
    set(handles.edit3,'String',(lambda+400));
    lambda=(lambda+400)*1e-9;
    s= get(handles.slider2,'value');%this is the distance between screen and slit in meters
    set(handles.edit2,'String',s);
    theta=-thetamax:1e-6:thetamax;
    y=s*tan(theta);
    alpha=pi*d*sin(theta)/lambda;
    x=((sinc(alpha)).^2); %(sin(alpha)./alpha).^2; 
    plot(y,x);
    title('Single slit diffraction ');
    xlabel('Distance (m)');
    ylabel('Intensity');
    
% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
thetamax=pi/10;
    d= str2double(get(hObject,'String'));
    set(handles.slider1,'Value',d);%this is the slit width in micro meter.............. check this 
    d=d*1e-6;  
    lambda= get(handles.slider3,'value');% this is the wavelength of light in nano meter
    set(handles.edit3,'String',(lambda+400));
    lambda=(lambda+400)*1e-9;
    s= get(handles.slider2,'value');%this is the distance between screen and slit in meters
    set(handles.edit2,'String',s);
    theta=-thetamax:1e-6:thetamax;
    y=s*tan(theta);
    alpha=pi*d*sin(theta)/lambda;
    x=((sinc(alpha)).^2); %(sin(alpha)./alpha).^2; 
    plot(y,x);
    title('Single slit diffraction ');
    xlabel('Distance (m)');
    ylabel('Intensity');
% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
thetamax=pi/10;
    d= get(handles.slider1,'value');%this is the slit width in micro meter.............. check this 
    set(handles.edit1,'String',d);
    d=d*1e-6;  
    lambda= get(handles.slider3,'value');% this is the wavelength of light in nano meter
    set(handles.edit3,'String',(lambda+400));
    lambda=(lambda+400)*1e-9;
    s= str2double(get(hObject,'String'));%this is the distance between screen and slit in meters
    set(handles.slider2,'value',s);
    theta=-thetamax:1e-6:thetamax;
    y=s*tan(theta);
    alpha=pi*d*sin(theta)/lambda;
    x=((sinc(alpha)).^2); %(sin(alpha)./alpha).^2; 
    plot(y,x);
    title('Single slit diffraction ');
    xlabel('Distance (m)');
    ylabel('Intensity');
% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
thetamax=pi/10;
    d= get(handles.slider1,'value');%this is the slit width in micro meter.............. check this 
    set(handles.edit1,'String',d);
    d=d*1e-6;  
    lambda= str2double(get(hObject,'String'));% this is the wavelength of light in nano meter
    set(handles.slider3,'value',lambda-400);
    lambda=(lambda+400)*1e-9;
    s= get(handles.slider2,'value');%this is the distance between screen and slit in meters
    set(handles.edit2,'String',s);
    theta=-thetamax:1e-6:thetamax;
    y=s*tan(theta);
    alpha=pi*d*sin(theta)/lambda;
    x=((sinc(alpha)).^2); %(sin(alpha)./alpha).^2; 
    plot(y,x);
    title('Single slit diffraction ');
    xlabel('Distance (m)');
    ylabel('Intensity');
% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


